
        let inactividadTiempo;
        let tiempoRestante = 300000; // 5 minutos en milisegundos

        // Función para redirigir al usuario y cerrar sesión
        function cerrarSesion() {
            // Aquí puedes hacer una solicitud para cerrar la sesión en el servidor, si es necesario
            // Por ejemplo, usando fetch para llamar a un endpoint de cierre de sesión en PHP
            fetch('logout.php')
                .then(response => {
                    // Redirigir al usuario al index.php
                    window.location.href = 'https://lacallecr.com/VV/index.php';
                })
                .catch(error => console.error('Error al cerrar sesión:', error));
        }

        // Función para mostrar SweetAlert antes de cerrar sesión
        function mostrarAlerta() {
            Swal.fire({
                title: 'Inactividad detectada',
                text: "Serás redirigido al inicio por inactividad",
                icon: 'warning',
                confirmButtonText: 'Ok'
            }).then((result) => {
                if (result.isConfirmed) {
                    cerrarSesion();
                }
            });
        }

        // Función para reiniciar el temporizador de inactividad
        function reiniciarTiempo() {
            clearTimeout(inactividadTiempo);
            tiempoRestante = 450000; // Reiniciar tiempo restante a 5 minutos
            inactividadTiempo = setTimeout(mostrarAlerta, tiempoRestante);
            iniciarContador();
        }

        // Función para iniciar el contador en la consola
        function iniciarContador() {
            clearInterval(contadorIntervalo);
            contadorIntervalo = setInterval(() => {
                tiempoRestante -= 1000;
               // console.log(`Tiempo restante de inactividad: ${tiempoRestante / 1000} segundos`);
                if (tiempoRestante <= 0) {
                    clearInterval(contadorIntervalo);
                }
            }, 1000);
        }

        // Variables para manejar los intervalos
        let contadorIntervalo;

        // Escuchar eventos de usuario para detectar actividad
        window.onload = reiniciarTiempo;
        document.onmousemove = reiniciarTiempo;
        document.onkeydown = reiniciarTiempo;
        document.onscroll = reiniciarTiempo;
        document.onclick = reiniciarTiempo;


window.onload = (event) => {

 console.log('The page has fully loaded');

}

$(document).ready(function(){
    //NEW TOPIC
    $('#frm_new').submit(function(e){
        e.preventDefault(); // Evita que el formulario se envíe automáticamente
        
        var title = $("#title").val();
        var cat = $("#category").val();
        var desc = $("#desc").val();
        

        console.log('****'+title+' -- '+cat+'///'+desc);
        if( title.length > 1 && cat !== null && desc.length > 1){
            console.log('https://lacallecr.com/VV/apps/Forum/proccess/actions.php?ac=topic&t='+title+'&c='+cat+'&desc='+desc)  ;
            fetch('https://lacallecr.com/VV/apps/Forum/proccess/actions.php?ac=topic&t='+title+'&c='+cat+'&desc='+desc)
            .then(function(response) {
          return response.json();//json
      }).then(function(data){

         if(data.control > 0){

            $("#btn_post").prop("disabled",true );

            Swal.fire({
                title: '¡PERFECTO!',
                text: 'Tu Tema fue creado, Una vez aprobado por la comisión va a ser publicado',
        icon: 'success', // Icono de éxito
        confirmButtonText: 'Aceptar' // Texto del botón de confirmación
    });

            setTimeout(function(){
                window.location.href = 'https://lacallecr.com/VV/apps/Forum/index.php'; 
        }, 5000); // Establece el mismo tiempo que el timer del Sweet Alert para que la redirección ocurra después

        } else {

           Swal.fire({
            icon: "error",
            title: "Oops...",
            text: "Hubo un error 22"

        });
       }

   }).catch(function(error){
    alert("A system error was detected");
});

} else {    

    Swal.fire({
        icon: "error",
        title: "Oops...",
        text: "Todos los campos son obligatorios",
        footer: '<a href="#">Favor corregir y volver a enviar</a>'
    });
}

});


  //APROBADO
    $('#frm_pending').submit(function(e){
        e.preventDefault(); // Evita que el formulario se envíe automáticamente
        
        var tema = $("#topic").val();
        var rev = $("#revision").val();
        var reply = $("#reply").val();
        console.log('****'+tema+' -- '+rev+'///'+reply);
        if( (reply.length > 1 && rev !== null ) || rev == 1){
            console.log('https://lacallecr.com/VV/apps/Forum/proccess/actions.php?ac=topicPending&t='+tema+'&r='+rev+'&reply='+reply)  ;
            fetch('https://lacallecr.com/VV/apps/Forum/proccess/actions.php?ac=topicPending&t='+tema+'&r='+rev+'&reply='+reply)
            .then(function(response) {
          return response.json();//json
      }).then(function(data){

         if(data.control > 0){

            Swal.fire({
                title: '¡Genial!',
                text: 'La Revisión del Tema ha sido exitosa',
        icon: 'success', // Icono de éxito
        confirmButtonText: 'Aceptar' // Texto del botón de confirmación
    });

            setTimeout(function(){
                window.location.href = 'https://lacallecr.com/VV/apps/Forum/pending.php'; 
        }, 5000); // Establece el mismo tiempo que el timer del Sweet Alert para que la redirección ocurra después

        } else {

           Swal.fire({
            icon: "error",
            title: "Oops...",
            text: "Hubo un error 22"

        });


       }

   }).catch(function(error){
    alert("A system error was detected");
});


} else {    

    Swal.fire({
        icon: "error",
        title: "Oops...",
        text: "Todos los campos son obligatorios",
        footer: '<a href="#">Favor corregir y volver a enviar</a>'
    });
}

});

// Reply

    $('#frm_topic').submit(function(e){
        e.preventDefault(); // Evita que el formulario se envíe automáticamente
        
        var tema = $("#topic").val();
       // var reply = $("#reply").val();

        var text = document.getElementById("reply").value;

    // Codificar el texto para URL
        var reply = encodeURIComponent(text);


        
        console.log('****'+tema+'///'+reply);
        if( reply.length > 1 && reply !== null ){
            console.log('https://lacallecr.com/VV/apps/Forum/proccess/actions.php?ac=reply&t='+tema+'&reply='+reply)  ;
           // exit;
            fetch('https://lacallecr.com/VV/apps/Forum/proccess/actions.php?ac=reply&t='+tema+'&reply='+reply)
            .then(function(response) {
          return response.json();//json
      }).then(function(data){

         if(data.control > 0){
            $("#btn_post").prop("disabled",true);
            Swal.fire({
                title: '¡Genial!',
                text: 'Su Respuesta ha sido Guardada',
        icon: 'success', // Icono de éxito
        confirmButtonText: 'Aceptar' // Texto del botón de confirmación
    });

            setTimeout(function(){
                window.location.href = 'https://lacallecr.com/VV/apps/Forum/index.php'; 
        }, 5000); // Establece el mismo tiempo que el timer del Sweet Alert para que la redirección ocurra después

        } else {

           Swal.fire({
            icon: "error",
            title: "Oops...",
            text: "Hubo un error 22"

        });


       }

   }).catch(function(error){
    alert("A system error was detected");
});


} else {    

    Swal.fire({
        icon: "error",
        title: "Oops...",
        text: "Todos los campos son obligatorios",
        footer: '<a href="#">Favor corregir y volver a enviar</a>'
    });
}

});



});



function logout(){

   console.log('https://lacallecr.com/VV/apps/login/proccess/actions.php?ac=logout')  ;
   fetch('https://lacallecr.com/VV/apps/login/proccess/actions.php?ac=logout')
   .then(function(response) {
          return response.json();//json
      }).then(function(data){

          if(data.login == 1){
            window.location.href = 'https://lacallecr.com/VV/';
        }
        
    }).catch(function(error){
        alert("A system error was detected");
    });

}


function closeTopicControl(){

    var tema = $("#topic").val();
    var reply = $("#reply").val();

    if( reply.length > 1 && reply !== null ){
       Swal.fire({
        title: '¿Estás seguro de Cerrar el caso?',
        text: "¡No podrás revertir esto!",
        icon: 'warning',
        showCancelButton: true,
        confirmButtonColor: '#3085d6',
        cancelButtonColor: '#d33',
        confirmButtonText: 'Sí',
        cancelButtonText: 'No'
    }).then((result) => {
        if (result.isConfirmed) {
                    // Si el usuario presiona "Sí"
            closeTopic();
            Swal.fire(
                '¡Confirmado!',
                'La acción ha sido confirmada.',
                'success'
                )
        } else {
                    // Opcional: Si quieres hacer algo si el usuario presiona "No"
            Swal.fire(
                'Cancelado',
                'La acción ha sido cancelada.',
                'error'
                )
        }
    })
}

else {    

    Swal.fire({
        icon: "error",
        title: "Oops...",
        text: "Todos los campos son obligatorios",
        footer: '<a href="#">Favor corregir y volver a enviar</a>'
    });
}



}

function closeTopic(){
    console.log('close');
    $('.active').hide();
    $('.closed').show();
    var tema = $("#topic").val();
    var reply = $("#reply").val();
   // console.log('****'+tema+' -- '+rev+'///'+reply);
    if( reply.length > 1  ){

        fetch('https://lacallecr.com/VV/apps/Forum/proccess/actions.php?ac=topicClose&t='+tema+'&reply='+reply)
        .then(function(response) {
          return response.json();//json
      }).then(function(data){

         if(data.control > 0){

            Swal.fire({
                title: '¡Genial!',
                text: 'El Tema ha sido Cerrado',
        icon: 'success', // Icono de éxito
        confirmButtonText: 'Aceptar' // Texto del botón de confirmación
    });

         setTimeout(function(){
                window.location.href = 'https://lacallecr.com/VV/apps/Forum/index.php'; 
        }, 5000); // Establece el mismo tiempo que el timer del Sweet Alert para que la redirección ocurra después

        } else {

           Swal.fire({
            icon: "error",
            title: "Oops...",
            text: "Hubo un error 22"

        });


       }

   }).catch(function(error){
    alert("A system error was detected");
});


}
}


function saveChanges(id,company){

    var element = $("#check_"+id+'_'+company);
    var value = 0;

    if ( element.is(':checked') ){
       value = 1;
   } else{
    value = 0;
    
}
//console.log("https://lacallecr.com/VV/apps/leagues/proccess/actions.php?ac=update&id="+id+"&c="+company+"&value="+value);

$.get("https://lacallecr.com/VV/apps/leagues/proccess/actions.php?ac=update&id="+id+"&c="+company+"&value="+value, function(data)  {


});

show_saving_message();
}


function viewControl(){
    var tema = $("#topic").val();
    var user = $("#user").val();
   // console.log("https://lacallecr.com/VV/apps/Forum/proccess/actions.php?ac=view&tema="+tema+"&user="+user);
//
    $.get("https://lacallecr.com/VV/apps/Forum/proccess/actions.php?ac=view&tema="+tema+"&user="+user, function(data) {});
}

function SearchTema(){
 var tema = $("#buscar").val();

 console.log('BUSCAR '+tema);

 window.location.href = ' https://lacallecr.com/VV/apps/Forum/index.php?s='+tema; 

}

function likes(res){
    var tema = $("#topic").val();
    var user = $("#user").val();
    //console.log("https://lacallecr.com/VV/apps/Forum/proccess/actions.php?ac=like&tema="+tema+"&user="+user+"&like="+res);
    $.get("https://lacallecr.com/VV/apps/Forum/proccess/actions.php?ac=like&tema="+tema+"&user="+user+"&like="+res, function(data) {});
  if(res){
    var contenido =  $("#slu_"+tema).text();
    var nuevoValor = parseInt(contenido) + 1;
    $("#slu_"+tema).text(nuevoValor);
    $('#lu_'+tema).addClass('disabled-link');
    $('#ld_'+tema).addClass('disabled-link');
 //   console.log('SI');  
  } else {
    var contenido =  $("#sld_"+tema).text();   
    var nuevoValor = parseInt(contenido) + 1;
    $("#sld_"+tema).text(nuevoValor);
    $('#ld_'+tema).addClass('disabled-link');
    $('#lu_'+tema).addClass('disabled-link');
  //  console.log('NO');

  }

}


function Rlikes(res,rid){
    var user = $("#user").val();
    console.log("https://lacallecr.com/VV/apps/Forum/proccess/actions.php?ac=Rlike&res="+rid+"&user="+user+"&like="+res);
    $.get("https://lacallecr.com/VV/apps/Forum/proccess/actions.php?ac=Rlike&res="+rid+"&user="+user+"&like="+res, function(data) {});
  if(res){
    var contenido =  $("#rslu_"+rid).text();
    var nuevoValor = parseInt(contenido) + 1;
    $("#rslu_"+rid).text(nuevoValor);
    $('#rlu_'+rid).addClass('disabled-link');
    $('#rld_'+rid).addClass('disabled-link');
    console.log('SI');  
  } else {
    var contenido =  $("#rsld_"+rid).text();   
    var nuevoValor = parseInt(contenido) + 1;
    $("#rsld_"+rid).text(nuevoValor);
    $('#rld_'+rid).addClass('disabled-link');
    $('#rlu_'+rid).addClass('disabled-link');
    console.log('NO');

  }

}

